<script>
import { socketStore } from '@/plugins/socket.js';
import { onDestroy } from 'svelte';
import { topics } from '@/plugins/store.js';

let derniers = [];
let unsubscribe;
$: {
    if (!unsubscribe) {
        socketStore.update((store) => {
            unsubscribe = store.subscribe(async message => {
                // Do something with the message here
                try {
                    let m = JSON.parse(message)
                    if (m.msg_type == "init") {
                        let messages = m.data
                        for (let i = 0; i < messages.length; i++) {
                            let msg = messages[i]
                            if (msg.topic == "/dons/derniers") {
                                for (let i = 0; i < msg.message.derniers.length; i++) {
                                    // is in derniers
                                    let isIn = false
                                    for (let j = 0; j < derniers.length; j++) {
                                        if (derniers[j].id == msg.message.derniers[i].id) {
                                            isIn = true
                                        }
                                    }
                                    if (!isIn) {
                                        await add(msg.message.derniers[i])
                                    }
                                }
                            }
                        }
                    } else {
                        let message = m.data.message
                        if (m.data.topic == "/dons/derniers") {
                            // Compare message.derniers with derniers to see if there's new people, if so, add them one by one
                            for (let i = 0; i < message.derniers.length; i++) {
                                // is in derniers
                                let isIn = false
                                for (let j = 0; j < derniers.length; j++) {
                                    if (derniers[j].id == message.derniers[i].id) {
                                        isIn = true
                                        console.log("is in")
                                    }
                                }
                                if (!isIn) {
                                    await add(message.derniers[i])
                                }
                            }
                        }
                    }
                } catch (e) {
                    console.log(e)
                }
            });
            return store;
        });
    }
}

async function add(person) {
    // Remove all classes
    let newD = derniers
    derniers = []
    // Wait a bit
    await new Promise(resolve => setTimeout(resolve, 1));
    for (let i = 0; i < newD.length; i++) {
        newD[i].class = "person"
    }
    derniers = newD
    await new Promise(resolve => setTimeout(resolve, 1));


    if (derniers.length < 10) {
        let newD = derniers
        newD.push({
            name: person.name,
            amount: person.amount,
            id: person.id,
            class: "person slide-in-left"
        })
        derniers = newD
        return
    }

    // Make sure it is applied
    derniers = [...derniers]
    await new Promise(resolve => setTimeout(resolve, 1));
    // Append a random name
    derniers.push({
        name: person.name,
        amount: person.amount,
        id: person.id,
        class: "person slide-in-left"
    })
    // Add a class to animate the first element
    derniers[0].class = "person slide-out-right"
    // Remove the first element after 1s
    setTimeout(() => {
        let newD = derniers
        newD.shift()
        newD[newD.length - 1].class = "person"
        derniers = []
        // Wait a bit
        setTimeout(() => {
            derniers = newD
        }, 1);
    }, 500);

    await new Promise(resolve => setTimeout(resolve, 200));
}

// Add a topic to the socket
topics.update(store => {
    store.push("/dons/derniers");
    return store;
});

socketStore.update(store => {
    store.send(JSON.stringify({"topics": $topics}));
    return store;
});

onDestroy(() => {
    unsubscribe();
    // Remove the topic from the socket
    topics.update(store => {
        store.splice(store.indexOf("/dons/derniers"), 1);
        return store;
    });
    socketStore.update(store => {
        store.send(JSON.stringify({"topics": $topics}));
        return store;
    });
});
</script>

<style>
    .person {
        /* Widget with boxes */
        color: #fff;
        text-shadow: 0 0 10px #000;
        background-color: #bbb;
        border: 1px solid #555;
        border-radius: 5px; 
        margin-top:1px;
        padding: 5px;
    }
    .slide-in-left{-webkit-animation:slide-in-left .5s cubic-bezier(.25,.46,.45,.94) both;animation:slide-in-left .5s cubic-bezier(.25,.46,.45,.94) both}
    .slide-out-right{-webkit-animation:slide-out-right .5s cubic-bezier(.55,.085,.68,.53) both;animation:slide-out-right .5s cubic-bezier(.55,.085,.68,.53) both}
    @keyframes slide-out-right{0%{-webkit-transform:translateX(0);transform:translateX(0);opacity:1}100%{-webkit-transform:translateX(1000px);transform:translateX(1000px);opacity:0}}@keyframes slide-out-right{0%{-webkit-transform:translateX(0);transform:translateX(0);opacity:1}100%{-webkit-transform:translateX(1000px);transform:translateX(1000px);opacity:0}}
    @keyframes slide-in-left{0%{-webkit-transform:translateX(-1000px);transform:translateX(-1000px);opacity:0}100%{-webkit-transform:translateX(0);transform:translateX(0);opacity:1}}@keyframes slide-in-left{0%{-webkit-transform:translateX(-1000px);transform:translateX(-1000px);opacity:0}100%{-webkit-transform:translateX(0);transform:translateX(0);opacity:1}}
</style>
    
<!-- -->
<div class="text-xl font-extrabold" style="background-color:transparent">
    {#each derniers as don}
        {#if don.name != undefined}
            <p class={don.class}>
                {don.name} a donné {don.amount/100}€
            </p>
        {/if}
    {/each}
</div>